##############################################################################
# 
#          FSQ80kr  
#           Heidenhain TNC-430
#
# System:  "Heidenhain TNC-430"
# Machine: "FSQ 80kr"
# Type: MILL 5x
#
################################################################################
# 
# $$
#
#
################################################################################

#=============================================================
#      .
#=============================================================
# source [MOM_ask_env_var UGII_CAM_DEBUG_DIR]mom_debug.tcl ;
 # source [MOM_ask_env_var UGII_CAM_DEBUG_DIR]mom_review.tcl ;
 # MOM_set_debug_mode ON

#=============================================================
#        .
#=============================================================

 source "[MOM_ask_env_var UGII_CAM_POST_DIR]ugpost_base.tcl"

#=============================================================
#    UGPost  .
#=============================================================

	set mom_kin_arc_valid_plane		XYZ
	set mom_kin_output_unit			MM
	set mom_kin_arc_output_mode             FULL_CIRCLE ; # QUADRANT FULL_CIRCLE
	set mom_kin_max_arc_radius		99999.999
	set mom_kin_min_arc_radius		0.01
#	set mom_kin_read_ahead_next_motion	TRUE
	set mom_kin_machine_resolution		0.001
	set mom_kin_machine_type		5_axis_dual_head
	set mom_kin_track_center_of_ball	FALSE
	set mom_kin_linearization_tol		0.01
	set mom_kin_linearization_flag		TRUE
	set mom_kin_nurbs_output_type		HEIDENHAIN_POLY
	set mom_kin_pivot_gauge_offset		0.0

	set mom_kin_4th_axis_plane		YZ
	set mom_kin_4th_axis_min_incr		0.001
	set mom_kin_4th_axis_min_limit		-180.000
	set mom_kin_4th_axis_max_limit		30.000
	set mom_kin_4th_axis_direction		MAGNITUDE_DETERMINES_DIRECTION
	set mom_kin_4th_axis_rotation		standard
	set mom_kin_4th_axis_zero		0.0
	set mom_kin_4th_axis_center_offset(0)	0.0
	set mom_kin_4th_axis_center_offset(1)	0.0
	set mom_kin_4th_axis_center_offset(2)	0.0
	set mom_kin_4th_axis_limit_action	"Retract / Re-Engage"

	set mom_kin_5th_axis_plane		ZX
	set mom_kin_5th_axis_min_incr		0.001
	set mom_kin_5th_axis_min_limit		-90.000
	set mom_kin_5th_axis_max_limit		90.000
	set mom_kin_5th_axis_direction		MAGNITUDE_DETERMINES_DIRECTION
	set mom_kin_5th_axis_rotation		standard
	set mom_kin_5th_axis_zero		0.0
	set mom_kin_5th_axis_limit_action	"Retract / Re-Engage"
	set mom_kin_5th_axis_center_offset(0)	0.0
	set mom_kin_5th_axis_center_offset(1)	0.0
	set mom_kin_5th_axis_center_offset(2)	0.0
  set mom_kin_clamp_time                        "2.0"
  set mom_kin_flush_time                        "2.0"
  set mom_kin_linearization_flag                "1"
  set mom_kin_linearization_tol                 "0.001"
  set mom_kin_max_arc_radius                    "9999.999"
  set mom_kin_max_dpm                           "5400"
  set mom_kin_max_fpm                           "15000"
  set mom_kin_max_fpr                           "1000"
  set mom_kin_max_frn                           "1000"
  set mom_kin_min_arc_length                    "0.01"
#  set mom_kin_min_arc_radius                    "0.001"
  set mom_kin_min_dpm                           "0.0"
  set mom_kin_min_fpm                           "0.1"
  set mom_kin_min_fpr                           "0.1"
  set mom_kin_min_frn                           "0.01"
  set mom_kin_post_data_unit                    "MM"
  set mom_kin_rapid_feed_rate                   "10000"
  set mom_kin_tool_change_time                  "0.3333" ; #  


#=============================================================
#       G  M 
#=============================================================

	set mom_sys_program_stop_code              	0
	set mom_sys_optional_stop_code             	1

	set mom_sys_spindle_direction_code(NONE)    	3
	set mom_sys_spindle_direction_code(CLW)    	3
	set mom_sys_spindle_direction_code(CCLW)        4
	set mom_sys_spindle_direction_code(OFF)    	5

	set mom_sys_tool_change_code               	6

	set mom_sys_coolant_code(MIST)             	7
	set mom_sys_coolant_code(FLOOD)            	8
	set mom_sys_coolant_code(ON)               	8
	set mom_sys_coolant_code(TAP)              	8
	set mom_sys_coolant_code(OFF)              	9

	set mom_sys_clamp_code(ON)                 	10
	set mom_sys_clamp_code(OFF)                	11
	set mom_sys_clamp_code(AXISON)             	10
	set mom_sys_clamp_code(AXISOFF)            	11

	set mom_sys_end_of_program_code            	30

	set mom_sys_rapid_code                     	0
	set mom_sys_linear_code                    	1
	set mom_sys_circle_code(CLW)               	2
	set mom_sys_circle_code(CCLW)              	3
	set mom_sys_mcs_rotation_code              	7

	set mom_sys_cutcom_code(OFF)               	"0"
	set mom_sys_cutcom_code(LEFT)              	"L"
	set mom_sys_cutcom_code(RIGHT)             	"R"

	set mom_sys_inch_code                      	70
	set mom_sys_metric_code                    	71

	set mom_sys_output_code(ABSOLUTE)          	90
	set mom_sys_output_code(INCREMENTAL)	        91

	set mom_sys_leader(Circle_radius) 		"R"

	set mom_sys_list_output				ON
	set mom_sys_commentary_output              	ON
	set mom_sys_header_output			ON
	set mom_sys_list_file_rows			80
	set mom_sys_list_file_columns			132
	set mom_sys_warning_output			OFF
	set mom_sys_group_output			OFF
	set mom_sys_list_file_suffix			lpt
	set mom_list_file_suffix			lpt
	set mom_sys_output_file_suffix			H
	set mom_output_file_suffix			H

	set mom_sys_home_pos(0)                		400
	set mom_sys_home_pos(1)                		200
	set mom_sys_home_pos(2)                		220
	set mom_tool_adjust_register                    0

#=============================================================
#   
#=============================================================

set header_check_status	            		0
set prog_start_flag                        	0
set prog_number                            	12345
set mom_cycle_rapid_to_pos(0)         		0
set mom_cycle_rapid_to_pos(1)        		0
set mom_cycle_rapid_to_pos(2)         		0
set mom_cycle_feed_to_pos(0)          		0
set mom_cycle_feed_to_pos(1)          		0
set mom_cycle_feed_to_pos(2)          		0
set mom_cycle_retract_to_pos(0)       		0
set mom_cycle_retract_to_pos(1)       		0
set mom_cycle_retract_to_pos(2)       		0
set mom_point1_pos(0) 				-100.0
set mom_point1_pos(1) 				-100.0
set mom_point1_pos(2) 				-50.0
set mom_point2_pos(0) 				100.0
set mom_point2_pos(1) 				100.0
set mom_point2_pos(2) 				0.0
set mom_offset_block				0.0
set mom_smooth_path				"OFF"
set mom_tolerance_on_off			"ON"
set tolerances				        0.03
set mom_small_steps				"OFF"
set status_block_create				0
set cutcom_on 					0
set mom_zero_point_set 				88
set status_tool_change				0
set mom_prev_pos_z				-9999.999
set first_move_after_MCSROT			0
set MCSROT_flag					0
set is_MCSROT_matrix_set			0
set first_motion_flag				0
set spindle_off_flag 				0
set mom_contact_status				UNDEFINED ; # ON
set mom_cycle_status				UNDEFINED
set mom_cycle_delay				0.1
set mom_output_vectors_on			"OFF"
set code_cutcom                                 0
set out_m114                                    115
set a_angle                                      0
set b_angle                                      0
set status_rot                                   0
set mom_angle_orient                             0
set   mom_machine_time_dmu_1                        0
set nn 0
set out_dist                                      0
  set  spind  0
   set   f_clamp     0
set  mom_coolant_status   "OFF"
set   mom_prev_out_angle_pos(0)   0
set   mom_prev_out_angle_pos(1)    0

#=============================================================
proc  MOM_start_of_program {} {
#       .
#=============================================================
	global mom_part_name
	global is_from
	global mom_cutcom_status mom_cutcom_mode
	global mom_spindle_rpm

#      UNDEFINED
	set mom_coolant_status 	UNDEFINED
	set mom_cutcom_status  	UNDEFINED
  	set mom_clamp_status   	UNDEFINED
  	set mom_cycle_status   	UNDEFINED
  	set mom_spindle_status 	UNDEFINED
  	set mom_cutcom_plane   	UNDEFINED

#   
	catch {unset mom_cutcom_adjust_register}
	catch {unset mom_tool_adjust_register}
  	catch {unset mom_tool_length_adjust_register}
  	catch {unset mom_length_comp_register}
  	catch {unset mom_flush_register}
  	catch {unset mom_wire_cutcom_adjust_register}

#     
	OPEN_files
#       
	LIST_FILE_HEADER

	global mom_warning_info
	set mom_warning_info "\n  FSQ-80KR ( - HEIDENHAIN)\n"
        MOM_output_to_listing_device $mom_warning_info  ; #  MOM_catch_warning ;

	set is_from ""
	set mom_spindle_rpm 0.0
}


#=============================================================
proc MOM_msys {} {
#       MOM_msys
#=============================================================
	global status_block_create mom_tolerance_on_off
	global status_zero_shift mom_spindle_speed tolerances zero_g_code
#         
#       iTNC-530
	if {$status_block_create == "0"} {
		MOM_block_create
#		MOM_output_literal "L M115"
	}
#        



}


#=============================================================
proc MOM_operator_message {} {
#        
#=============================================================
     global mom_operator_message
     MOM_output_literal ";$mom_operator_message"
}


#=============================================================
proc MOM_end_of_program { } {
#       
#=============================================================
   	global mom_machine_time mom_kin_tool_change_time mom_tool_count mom_operation_type mom_template_type
   	global line1 mom_angle_orient mom_machine_time_dmu_1 warning_1 nn out_dist mom_out_angle_pos

if {[format "%.6f" $mom_out_angle_pos(0)]==-90 } {
MOM_output_literal "L M115"
}
   if {$mom_angle_orient!=0 } {
    	MOM_output_literal "L M115"
}
    	MOM_output_literal "M30"

    	set machine_time $mom_machine_time_dmu_1
    	set machine_time [ expr ($mom_tool_count*$mom_kin_tool_change_time + $machine_time ) ]
    	set line1 [format "; MACHINE TIME = %.2f min " $machine_time ]
  	set tm1 [ expr int($machine_time/60.0) ]
  	set tm2 [ expr ($machine_time/60.0 - $tm1) * 60.0 ]
  	set line2 [format "( %.0f hour %.0f min)" $tm1 $tm2]
  	if {$tm1!=0} { append line1 $line2 ; }
  	set mom_machine_time $machine_time

  	set out_dist [ expr ($out_dist/1000.0) ]
  	set line22 [format ";   =%.3f  " $out_dist ]

    	MOM_output_literal "$line1"
    	MOM_output_literal "$line22"

    	     for {set l 1} {$l <= $nn} {incr l} {
    	MOM_output_literal "$warning_1($l)"
}
  global prog_name
	MOM_output_literal "END PGM $prog_name MM"

  	LIST_FILE_TRAILER

  	CLOSE_files

  	catch { minmaxHEIDENHAIN }
}


#=============================================================
proc MOM_before_motion { } {
#=============================================================
  global mom_motion_event mom_motion_type

    FEEDRATE_SET


#    switch $mom_motion_type {
#      ENGAGE   {PB_engage_move}
#      APPROACH {PB_approach_move}
#      FIRSTCUT {PB_first_cut}
#      RETRACT  {PB_retract_move}
#      RETURN   {PB_return_move}
#    }

    if [llength [info commands PB_CMD_kin_before_motion] ] { PB_CMD_kin_before_motion }
    if [llength [info commands PB_CMD_before_motion] ]     { PB_CMD_before_motion }
}


#=============================================================
proc MOM_nurbs_move { } {
#       
#=============================================================
	global mom_nurbs_point_count
	global mom_nurbs_points
	global mom_nurbs_coefficients
	global xe ye ze
	global ii
	global x0 x1 x2
	global y0 y1 y2
	global z0 z1 z2
	global E_string_x0 E_string_x1 E_string_x2
	global E_string_y0 E_string_y1 E_string_y2
	global E_string_z0 E_string_z1 E_string_z2
	global nurbs_precision
	global comp_value mom_smooth_path

	set E_string_x0 ""
	set E_string_x1 ""
	set E_string_x2 ""
	set E_string_y0 ""
	set E_string_y1 ""
	set E_string_y2 ""
	set E_string_z0 ""
	set E_string_z1 ""
	set E_string_z2 ""

	MOM_force once X Y Z K3X K2X K1X K3Y K2Y K1Y K3Z K2Z K1Z

	set xe $mom_nurbs_points(0,0)
	set ye $mom_nurbs_points(0,1)
	set ze $mom_nurbs_points(0,2)

#	if {$mom_smooth_path == "ON"} {
#		MOM_do_template start_spline_m90
#	} else  {
#		MOM_do_template start_spline
#	}



	for {set ii 0} {$ii < [expr $mom_nurbs_point_count]} {incr ii} {
		set xe $mom_nurbs_points($ii,0)
		set ye $mom_nurbs_points($ii,1)
		set ze $mom_nurbs_points($ii,2)
		set nurbs_precision 1.0
	MOM_force once X Y Z K3X K2X K1X K3Y K2Y K1Y K3Z K2Z K1Z
		set x0 [expr $mom_nurbs_coefficients($ii,0)*$nurbs_precision]
		set x1 [expr $mom_nurbs_coefficients($ii,1)*$nurbs_precision]
		set x2 [expr $mom_nurbs_coefficients($ii,2)*$nurbs_precision]
		set y0 [expr $mom_nurbs_coefficients($ii,3)*$nurbs_precision]
		set y1 [expr $mom_nurbs_coefficients($ii,4)*$nurbs_precision]
		set y2 [expr $mom_nurbs_coefficients($ii,5)*$nurbs_precision]
		set z0 [expr $mom_nurbs_coefficients($ii,6)*$nurbs_precision]
		set z1 [expr $mom_nurbs_coefficients($ii,7)*$nurbs_precision]
		set z2 [expr $mom_nurbs_coefficients($ii,8)*$nurbs_precision]

		set comp_value [expr abs($x0)]

		if { $comp_value  >= 10.0 && $comp_value < 100.0} {
			set x0 [expr $x0/10.0] ; set E_string_x0 "E1"
		} elseif { $comp_value >= 100.0 && $comp_value < 1000.0} {
			set x0 [expr $x0/100.0] ; set E_string_x0 "E2"
		} elseif { $comp_value >=  1000.0 && $comp_value < 10000.0} {
			set x0 [expr $x0/1000.0] ; set E_string_x0 "E3"
		} elseif { $comp_value >=  10000.0 && $comp_value < 100000.0} {
			set x0 [expr $x0/10000.0] ; set E_string_x0 "E4"
		} else { set E_string_x0 ""}

		set comp_value [expr abs($x1)]

		if { $comp_value >=  10.0 && $comp_value < 100.0} {
			set x1 [expr $x1/10.0] ; set E_string_x1 "E1"
		} elseif { $comp_value >=  100.0 && $comp_value < 1000.0} {
			set x1 [expr $x1/100.0] ; set E_string_x1 "E2"
		} elseif { $comp_value >=  1000.0 && $comp_value < 10000.0} {
			set x1 [expr $x1/1000.0] ; set E_string_x1 "E3"
		} elseif { $comp_value >=  10000.0 && $comp_value < 100000.0} {
			set x1 [expr $x1/10000.0] ; set E_string_x1 "E4"
		} else {
			set E_string_x1 ""}

		set comp_value [expr abs($x2)]

		if {$comp_value >=  10.0 && $comp_value < 100.0} {
			set x2 [expr $x2/10.0] ; set E_string_x2 "E1"
		} elseif { $comp_value >=  100.0 && $comp_value < 1000.0} {
			set x2 [expr $x2/100.0] ; set E_string_x2 "E2"
		} elseif { $comp_value >=  1000.0 && $comp_value < 10000.0} {
			set x2 [expr $x2/1000.0] ; set E_string_x2 "E3"
		} elseif { $comp_value >=  10000.0 && $comp_value < 100000.0} {
			set x2 [expr $x2/10000.0] ; set E_string_x2 "E4"
		} else {set E_string_x2 ""}

		set comp_value [expr abs($y0)]

		if {$comp_value >=  10.0 && $comp_value < 100.0} {
			set y0 [expr $y0/10.0] ; set E_string_y0 "E1"
		} elseif { $comp_value >=  100.0 && $comp_value < 1000.0} {
			set y0 [expr $y0/100.0] ; set E_string_y0 "E2"
		} elseif { $comp_value >=  1000.0 && $comp_value < 10000.0} {
			set y0 [expr $y0/1000.0] ; set E_string_y0 "E3"
		} elseif { $comp_value >=  10000.0 && $comp_value < 100000.0} {
			set y0 [expr $y0/10000.0] ; set E_string_y0 "E4"
		} else {set E_string_y0 ""}

		set comp_value [expr abs($y1)]

		if { $comp_value >=  10.0 && $comp_value < 100.0} {
			set y1 [expr $y1/10.0] ; set E_string_y1 "E1"
		} elseif { $comp_value >=  100.0  && $comp_value < 1000.0} {
			set y1 [expr $y1/100.0] ; set E_string_y1 "E2"
		} elseif { $comp_value >=  1000.0  && $comp_value < 10000.0} {
			set y1 [expr $y1/1000.0] ; set E_string_y1 "E3"
		} elseif { $comp_value >=  10000.0  && $comp_value < 100000.0} {
			set y1 [expr $y1/10000.0] ; set E_string_y1 "E4"
		} else {set E_string_y1 ""}

		set comp_value [expr abs($y2)]

		if { $comp_value >=  10.0 && $comp_value < 100.0} {
			set y2 [expr $y2/10.0] ; set E_string_y2 "E1"
		} elseif { $comp_value >=  100.0 && $comp_value < 1000.0} {
			set y2 [expr $y2/100.0] ; set E_string_y2 "E2"
		} elseif { $comp_value >=  1000.0 && $comp_value < 10000.0} {
			set y2 [expr $y2/1000.0] ; set E_string_y2 "E3"
		} elseif { $comp_value >=  10000.0 && $comp_value < 100000.0} {
			set y2 [expr $y2/10000.0] ; set E_string_y2 "E4"
		} else {set E_string_y2 ""}

		set comp_value [expr abs($z0)]

		if { $comp_value >=  10.0 && $comp_value < 100.0} {
			set z0 [expr $z0/10.0] ; set E_string_z0 "E1"
		} elseif { $comp_value >=  100.0 && $comp_value < 1000.0} {
			set z0 [expr $z0/100.0] ; set E_string_z0 "E2"
		} elseif {$comp_value >=  1000.0 && $comp_value < 10000.0} {
			set z0 [expr $z0/1000.0] ; set E_string_z0 "E3"
		} elseif {$comp_value >=  10000.0 && $comp_value < 100000.0} {
			set z0 [expr $z0/10000.0] ; set E_string_z0 "E4"
		} else {set E_string_z0 ""}

		set comp_value [expr abs($z1)]

		if {$comp_value >=  10.0 && $comp_value < 100.0} {
			set z1 [expr $z1/10.0] ; set E_string_z1 "E1"
		} elseif {$comp_value >=  100.0 && $comp_value < 1000.0} {
			set z1 [expr $z1/100.0] ; set E_string_z1 "E2"
		} elseif {$comp_value >=  1000.0 && $comp_value < 10000.0} {
			set z1 [expr $z1/1000.0] ; set E_string_z1 "E3"
		} elseif {$comp_value >=  10000.0 && $comp_value < 100000.0} {
			set z1 [expr $z1/10000.0] ; set E_string_z1 "E4"
		} else {set E_string_z1 ""}

		set comp_value [expr abs($z2)]

		if { $comp_value >=  10.0 && $comp_value < 100.0} {
			set z2 [expr $z2/10.0] ; set E_string_z2 "E1"
		} elseif {$comp_value >=  100.0 && $comp_value < 1000.0} {
			set z2 [expr $z2/100.0] ; set E_string_z2 "E2"
		} elseif {$comp_value >=  1000.0 && $comp_value < 10000.0} {
			set z2 [expr $z2/1000.0] ; set E_string_z2 "E3"
		} elseif {$comp_value >=  10000.0 && $comp_value < 100000.0} {
			set z2 [expr $z2/10000.0] ; set E_string_z2 "E4"
		} else {set E_string_z2 ""}

		if {$mom_smooth_path == "ON"} {
			MOM_do_template spline_tnc_m90
		} else  {
			MOM_do_template spline_tnc
		}
	}
}
#=============================================================
proc MOM_machine_mode {} {
#=============================================================
  global pb_start_of_program_flag
  global mom_operation_name mom_sys_change_mach_operation_name spind mom_spindle_speed

   set mom_sys_change_mach_operation_name $mom_operation_name

    if {$pb_start_of_program_flag == 0} {PB_start_of_program ; set pb_start_of_program_flag 1}

    if [llength [info commands PB_machine_mode] ] {
       if [catch {PB_machine_mode} res] {
          global mom_warning_info
          set mom_warning_info "$res"
          MOM_catch_warning
       }
    }
}


#=============================================================
proc  MOM_start_of_path {} {
#       .
#=============================================================
	global mom_path_name
	global mom_tool_name
	global mom_out_angle_pos mom_spindle_speed spind

if {$mom_spindle_speed != $spind} {
			set line_tool [format "TOOL CALL S%.0f" $mom_spindle_speed ]
			MOM_output_literal "$line_tool"
		} 
  set  spind  $mom_spindle_speed
	MOM_force once motion_g G M_spindle  X Y Z R F Axis_4th Axis_5th

}


#=============================================================
proc  MOM_end_of_path {} {
#       
#=============================================================
	global mom_path_name
	global first_motion_flag

	set first_motion_flag 0
	MOM_suppress off I J K
}


#=============================================================
proc MOM_start_of_group {} {
#      UG   ,
#    
#=============================================================
	global mom_output_file_basename mom_group_name
	global header_check_status mom_operation_name
	global mom_date mom_machine_name mom_logname
	global mom_ug_version spind mom_spindle_speed

  global prog_name
  set prog_name ""
  if {[info exists mom_operation_name]} { set prog_name $mom_operation_name }
  if {[info exists mom_group_name]} { set prog_name $mom_group_name }

	set prog_name $mom_output_file_basename

	if { $header_check_status == 0} {
		set prog_name [string toupper $prog_name]
		MOM_output_literal "BEGIN PGM $prog_name MM"
 		MOM_do_template sel_table
		set mom_ug_version [string toupper $mom_ug_version]
		MOM_output_literal "; GENERATE BY: $mom_ug_version"
		set mom_machine_name [string toupper $mom_machine_name]
		MOM_output_literal "; MACHINE: $mom_machine_name"
		set mom_date [string toupper $mom_date]
		MOM_output_literal "; DATE: $mom_date"
		set mom_logname [string toupper $mom_logname]
		MOM_output_literal "; PROGRAMMER: $mom_logname"
		set header_check_status 1
	}
  set  spind  $mom_spindle_speed 

}


#=============================================================
proc MOM_end_of_group {} {
#      
#=============================================================
}


#=============================================================
proc  MOM_tool_change {} {
#      
#=============================================================
	global mom_tool_name status_tool_change
	set status_tool_change 0
}


#=============================================================
proc  MOM_first_tool {} {
#       
#=============================================================
	global mom_tool_name
}


#=============================================================
proc  MOM_initial_move {} {
#         .
#=============================================================
	global first_motion_flag mom_cycle_status mom_motion_type mom_out_angle_pos mom_angle_orient mom_tolerance_on_off
	global mom_prev_pos_z mom_pos_z leader_4th leader_5th status_rot rot_table_1 rot_table_2 rot_table_3
      global mom_prev_out_angle_pos mom_operation_type f_clamp
#     ,     
#     ,    .
# *************=-90   ************
	set leader_4th "A"
	set leader_5th "B"
#    
#        
	if {$mom_tolerance_on_off == "ON"} {
  		MOM_do_template tolerances_1
  		MOM_do_template tolerances_2
  	}
	MOM_spindle_rpm
#     ,  =-90,          , 
#        =-90
   if {$mom_angle_orient==0 } {

   if {[format "%.6f" $mom_out_angle_pos(0)]==-90 } {
	MOM_output_literal "L A-90 B0 R0 FMAX"

	MOM_force once  motion_g G X Y Z M Axis_4th Axis_5th T F
	if {$mom_motion_type == "RAPID"} {
	
		MOM_do_template rapid_xyz
	} else {
		MOM_linear_move
	}

		} else {
	MOM_output_literal "L A0 B0 R0 FMAX"
   	MOM_force once  X Y Z
	MOM_do_template from_move
set  ff1 [format "%.6f" $mom_prev_out_angle_pos(0)]  
set  ff2 [format "%.6f" $mom_prev_out_angle_pos(1)] 
set  f1 [format "%.6f" $mom_out_angle_pos(0)] 
set  f2 [format "%.6f" $mom_out_angle_pos(1)] 
if { $mom_operation_type=="Point to Point" } {
       if {$ff1!=$f1 || $ff2!=$f2} {
                 MOM_output_literal "L M44"
                 MOM_output_literal "L M45"
     set   f_clamp   1
  }
      if {$ff1==$f1 && $ff2==$f2 && $f_clamp==1} {
                 MOM_output_literal "L M64"
                 MOM_output_literal "L M65"
     set   f_clamp   0
  }

}


 	MOM_force once  motion_g G X Y Z M Axis_4th Axis_5th T F
	if {$mom_motion_type == "RAPID"} {
		if {$mom_cycle_status == "ON"} {
			MOM_do_template rapid_cycle_z
			MOM_do_template rapid_cycle_xy
		} else {
			MOM_do_template rapid_xy
			MOM_do_template rapid_z
		}
	} elseif {$mom_motion_type == "CYCLE"} {
		MOM_do_template rapid_cycle_z
		MOM_do_template rapid_cycle_xy
	} else {
		MOM_linear_move
	}
}
}

	set first_motion_flag 1
	if {$status_rot == 1} {
		MOM_do_template rotate_ab
	MOM_output_literal "$rot_table_1"
		if {[info exists rot_table_2]} {
		MOM_output_literal "$rot_table_2"
	}
		if {[info exists rot_table_3]} {
		MOM_output_literal "$rot_table_3"
	}
	set status_rot  0
	}
}


#=============================================================
proc PROGRAM_START {} {
#      User Define Command
# "PARTNO"
#=============================================================
	global prog_start_flag
	global prog_number

	if {$prog_start_flag == 0} {
		MOM_suppress always N
		MOM_output_literal "BEGIN PRG $prog_number MM"
		MOM_suppress off    N
		set prog_start_flag 1
	}
}


#=============================================================
proc MOM_block_create { } {
#    2-  3-   ,  
#      
#=============================================================
	global mom_point1_pos
	global mom_point2_pos
	global status_block_create
	global mom_offset_block

	MOM_force once X Y Z
	set mom_point1_pos(0) [expr $mom_point1_pos(0)-$mom_offset_block]
	set mom_point1_pos(1) [expr $mom_point1_pos(1)-$mom_offset_block]
	set mom_point1_pos(2) [expr $mom_point1_pos(2)-$mom_offset_block]
	set mom_point2_pos(0) [expr $mom_point2_pos(0)+$mom_offset_block]
	set mom_point2_pos(1) [expr $mom_point2_pos(1)+$mom_offset_block]
	MOM_do_template start_block
	MOM_do_template end_block
	set status_block_create 1
}


#=============================================================
proc MOM_first_move {} {
#        ,
#       .
#=============================================================
	global mom_motion_event
	global first_motion_flag

	catch { MOM_$mom_motion_event }
	set first_motion_flag 1
}


#=============================================================
proc MOM_from_move { } {
#       FROM,   .
#=============================================================
 global mom_from_pos
 catch { COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET ;  MODES_SET ; }
}


#=============================================================
proc MOM_gohome_move {} {
#       GOHOME,   .
#=============================================================
	global mom_pos mom_prev_pos mom_gohome_pos
	global leader_4th leader_5th mom_output_vectors_on

	if {$mom_pos(2) < $mom_prev_pos(2) } {
	if {$mom_output_vectors_on == "ON"} {
		MOM_force once X Y Z TX TY TZ
		MOM_do_template gohome_xy_vectors
	} else {
   		MOM_do_template gohome_xy
                }
   		MOM_do_template gohome_z

   	} else {
	if {$mom_output_vectors_on == "ON"} {
		MOM_force once X Y Z TX TY TZ
		MOM_do_template gohome_z_vectors
	} else {
   		MOM_do_template gohome_z
                 }
   		MOM_do_template gohome_xy

            }

#   	set mom_prev_pos_z $mom_pos_z
}


#=============================================================
proc MOM_linear_move { } {
#       .
#=============================================================
	global cutcom_mode mom_cutcom_mode mom_cutcom_status
	global mom_pos mom_prev_pos
	global mom_smooth_path mom_small_steps
	global mom_motion_distance mom_tool_diameter
	global cutcom_on mom_contact_status
	global mom_output_vectors_on
	global mom_tool_axis mom_feed_rate mom_motion_type feed

	set al1 [COUNT_alk $mom_pos(0) $mom_pos(1) al1]
#       MOM_output_literal "al1=  $al1"

	PB_limit_angle

	if {$mom_contact_status == "ON"} {
		MOM_force once X Y Z NX NY NZ
		MOM_do_template linear_move_3d
	} elseif {$mom_output_vectors_on == "ON"} {
		MOM_force once X Y Z TX TY TZ
		MOM_do_template linear_move_vectors
	} else {
		if {$mom_small_steps == "ON" 		&&
			$mom_cutcom_status == "ON"	&&
			$mom_motion_distance <= $mom_tool_diameter} {
				MOM_do_template feedrate_tnc
				MOM_do_template linear_move_m97
		} elseif {$mom_smooth_path == "ON"} {
			if {$cutcom_on == 1} {
				MOM_do_template linear_move
				set cutcom_on 0
			} else {
				MOM_do_template feedrate_tnc
				MOM_do_template linear_move_m90
			}
		} else  {
			#         Z   	RAPID
    set   a1 [ expr ($mom_pos(0)-$mom_prev_pos(0) )]
    set   a2 [ expr ($mom_pos(1)-$mom_prev_pos(1) )]
    set   a3 [ expr ($mom_pos(2)-$mom_prev_pos(2) )]
	if {$a1==0.0 && $a2==0.0 && $a3!=0.0 && $mom_motion_type =="RAPID" &&$feed>600.0} {
#   			MOM_output_literal "$a1 $a2  $a3"
	        	set feed 600
	        }
			MOM_do_template linear_move
		}
	}
}


#=============================================================
proc MOM_circular_move { } {
#=============================================================
	global mom_arc_direction
	global mom_arc_axis out_m114

   	if { $out_m114 == 114} {
		MOM_abort "       !!!!!"
   	}

	if {[format "%.6f" $mom_arc_axis(2)] == "1" || [format "%.6f" $mom_arc_axis(2)] == "-1"} {
		MOM_force once XC YC
		MOM_suppress once ZC
	} elseif {[format "%.6f" $mom_arc_axis(1)] == "1" || [format "%.6f" $mom_arc_axis(1)] == "-1"} {
		 MOM_force once XC ZC
		 MOM_suppress once YC
	} elseif {[format "%.6f" $mom_arc_axis(0)] == "1" || [format "%.6f" $mom_arc_axis(0)] == "-1"} {
		 MOM_force once YC ZC
		 MOM_suppress once XC
	}
	;#MOM_do_template feedrate_tnc
   	MOM_do_template circle_center
   	if {[format "%.6f" $mom_arc_axis(2)] == "1" || [format "%.6f" $mom_arc_axis(2)] == "-1"} {
		 MOM_force once X Y
		MOM_suppress once Z
	} elseif {[format "%.6f" $mom_arc_axis(1)] == "1" || [format "%.6f" $mom_arc_axis(1)] == "-1"} {
		 MOM_force once X Z
		 MOM_suppress once Y
	} elseif {[format "%.6f" $mom_arc_axis(0)] == "1" || [format "%.6f" $mom_arc_axis(0)] == "-1"} {
		 MOM_force once Y Z
		 MOM_suppress once X
	}
   	if { $mom_arc_direction == "CLW"} {
      		MOM_do_template circle_end_cw
   	} elseif { $mom_arc_direction == "CCLW" } {
     		MOM_do_template circle_end_ccw
   	}
}


#=============================================================
proc MOM_circular_move_1 { } {
#       .
#=============================================================
	global mom_arc_direction mom_arc_radius
	global mom_arc_axis mom_arc_angle
	global delta_x delta_y delta_z mom_pos mom_pos_arc_center
	global mom_operation_type mom_motion_type mom_arc_angle
	global mom_arc_center mom_prev_mcs_goto

	set mom_arc_radius [expr abs($mom_arc_radius)]
	set mom_arc_axis(0) [format %.7f $mom_arc_axis(0)]
	set mom_arc_axis(1) [format %.7f $mom_arc_axis(1)]
	set mom_arc_axis(2) [format %.7f $mom_arc_axis(2)]

	if {$mom_arc_axis(2) == "1" || $mom_arc_axis(2) == "-1"} {
		MOM_force once X Y
		MOM_suppress once ZC
	} elseif {$mom_arc_axis(1) == "1" || $mom_arc_axis(1) == "-1"} {
		MOM_force once X Z
		MOM_suppress once Y
	} elseif {$mom_arc_axis(0) == "1" || $mom_arc_axis(0) == "-1"} {
		MOM_force once Y Z
		MOM_suppress once X
	}
	if {$mom_arc_angle > 180.000} {
		set mom_arc_radius [expr $mom_arc_radius * -1.0]
	}
	if {$mom_arc_angle >= 360.000} {
		if { $mom_arc_direction == "CLW"} {
			set delta_x [expr [expr $mom_pos_arc_center(0)-$mom_pos(0)]*2]
			set delta_y [expr [expr $mom_pos_arc_center(1)-$mom_pos(1)]*2]
			set delta_z [expr [expr $mom_pos_arc_center(2)-$mom_pos(2)]*2]
      			MOM_do_template full_circle_1_cw
      			MOM_do_template full_circle_2_cw
   		} elseif { $mom_arc_direction == "CCLW" } {
			set delta_x [expr [expr $mom_pos_arc_center(0)-$mom_pos(0)]*2]
			set delta_y [expr [expr $mom_pos_arc_center(1)-$mom_pos(1)]*2]
			set delta_z [expr [expr $mom_pos_arc_center(2)-$mom_pos(2)]*2]
     			MOM_do_template full_circle_1_ccw
      			MOM_do_template full_circle_2_ccw
		}
		return
	}
#	if { $mom_arc_direction == "CLW"} {
#      		MOM_do_template circle_end_cw
#   	} elseif { $mom_arc_direction == "CCLW" } {
#     		MOM_do_template circle_end_ccw
#   	}

	set mom_arc_center(0) [format %.7f $mom_arc_center(0)]
	set mom_arc_center(1) [format %.7f $mom_arc_center(1)]
	set mom_arc_center(2) [format %.7f $mom_arc_center(2)]
	set mom_prev_mcs_goto(0) [format %.7f $mom_prev_mcs_goto(0)]
	set mom_prev_mcs_goto(1) [format %.7f $mom_prev_mcs_goto(1)]
	set mom_prev_mcs_goto(2) [format %.7f $mom_prev_mcs_goto(2)]

	if {$mom_arc_center(0) == $mom_prev_mcs_goto(0)} {
		MOM_force once YC ZC
		MOM_suppress once XC
	} elseif {$mom_arc_center(1) == $mom_prev_mcs_goto(1)} {
		MOM_force once XC ZC
		MOM_suppress once YC
	} elseif {$mom_arc_center(2) == $mom_prev_mcs_goto(2)} {
		MOM_force once XC YC
		MOM_suppress once ZC
	}
	if { $mom_arc_direction == "CLW"} {
      		MOM_do_template circle_end_cw
#		MOM_do_template circle_center
#      		MOM_do_template circle_end_cw1
   	} elseif { $mom_arc_direction == "CCLW" } {
     		MOM_do_template circle_end_ccw
#   		MOM_do_template circle_center
#     		MOM_do_template circle_end_ccw1
   	}
}


#=============================================================
proc  MOM_rapid_move {} {
#     .
#=============================================================
	global mom_coolant_mode mom_coolant_status mom_output_vectors_on
	global mom_pos mom_prev_pos mom_pos_z mom_prev_pos_z

	set mom_coolant_status $mom_coolant_mode
	if {$mom_output_vectors_on == "ON"} {
		MOM_force once X Y Z TX TY TZ
		MOM_do_template rapid_xyz_vectors
	} else {
              MOM_do_template rapid_xyz

   	}
#   	set mom_prev_pos_z $mom_pos_z
}


##################################################################################################


#=============================================================
proc PB_CMD_cycle_init { } {
#=============================================================
  global cycle_name ;
  global cycle_init_flag ;

	global mom_motion_event
	global mom_tool_diameter
	global mom_pos mom_prev_pos
	global mom_alt_pos  mom_prev_alt_pos
	global mom_cycle_delay  mom_cycle_delay_revs  mom_cycle_delay_mode
 	global mom_cycle_step1 mom_cycle_step2  mom_cycle_step3
  	global mom_cycle_feed_to mom_cycle_feed_to_pos
	global mom_cycle_retract_mode  mom_cycle_retract_to
	global mom_cycle_clearance_plane
	global mom_cycle_cam

  	global dwell_at_top
  	global surface_coordinate
  	global depth_bottom
  	global step1  step2  step3

  global cycle_step ;

  #   
  if {$mom_prev_alt_pos(2)!=$mom_alt_pos(2)} { set  cycle_step  0; }

  if {$cycle_step==0} {

  	set surface_coordinate  $mom_alt_pos(2)
	set depth_bottom  [ expr $mom_cycle_feed_to_pos(2) - $mom_alt_pos(2) ]
  	set dwell_at_top  0.0
	set step1  $mom_cycle_step1
	if {$step1==0.0} { set step1 [ expr abs($depth_bottom) ] ; }

	switch $cycle_name {

	 DRILL {

 	MOM_force once Q200 Q201 Q206 Q202 Q210 Q203 Q204
 	MOM_suppress Always  Q211

 	MOM_do_template cycle_200_drill

  	# MOM_do_template cycle_200
  	# MOM_suppress always N
  	# MOM_do_template tnc_q200 ; # 1-  
  	# MOM_do_template tnc_q201 ; # 
  	# MOM_do_template tnc_q206 ; #    
  	# MOM_do_template tnc_q202 ; # 
  	# MOM_do_template tnc_q210 ; #    
  	# MOM_do_template tnc_q203 ; #  
 	# MOM_do_template tnc_q204 ; # 2-  
	# MOM_suppress off    N

	}

	DRILL_DWELL {

  	MOM_force once Q200 Q201 Q206 Q202 Q210 Q203 Q204 Q211

  	MOM_do_template cycle_200_drill

  	# MOM_do_template cycle_200
  	# MOM_suppress always N
  	# MOM_do_template tnc_q200 ; # 1-  
  	# MOM_do_template tnc_q201 ; # 
  	# MOM_do_template tnc_q206 ; #    
  	# MOM_do_template tnc_q202 ; # 
  	# MOM_do_template tnc_q210 ; #    
  	# MOM_do_template tnc_q203 ; #  
 	# MOM_do_template tnc_q204 ; # 2-  
  	# MOM_do_template tnc_q211 ; #    
	# MOM_suppress off   N
	}

	DRILL_DEEP {

	MOM_force once Q200 Q201 Q206 Q202 Q210 Q203 Q204 Q211 Q212 Q213 Q205 Q208 Q256

	set step1  $mom_cycle_step1
	set step2  $mom_cycle_step2
	set step3  $mom_cycle_step3
	if {$step1==0.0} {
	  set step1 $mom_tool_diameter ;
	  set step2 0.0 ;
	 } else {
 	     if {$step2<0.0} {
 	        set step2 [ expr abs($step2) ] ;
 	      } else {
 	     	if {$step2<=$step1} { set step2 [ expr $step1 - $step2 ] ; }
 	     	}
 	  }
	if {$step3==0.0} { set mom_cycle_cam 0 ; }
        if {$mom_cycle_cam==0} { set  step3 0.0 ;  }

	MOM_do_template cycle_203_drill_deep

	#if {$mom_cycle_delay==0.0} { MOM_suppress Always Q211 ; }

  	#MOM_do_template cycle_203
  	#MOM_suppress always N
  	#MOM_do_template tnc_q200 ; # 1-  
  	#MOM_do_template tnc_q201 ; # 
  	#MOM_do_template tnc_q206 ; #    
  	#MOM_do_template tnc_q202 ; #  
  	#MOM_do_template tnc_q210 ; #    
  	#MOM_do_template tnc_q203 ; #  
 	#MOM_do_template tnc_q204 ; # 2-  
 	#MOM_do_template tnc_q212 ; #    
  	#MOM_do_template tnc_q213 ; #   
  	#MOM_do_template tnc_q205 ; # .  
  	#MOM_do_template tnc_q211 ; #    
  	#MOM_do_template tnc_q208 ; #      
	#MOM_force once Q256
  	#MOM_do_template tnc_q256 ; #     
  	#MOM_suppress off    N
	}

	DRILL_BREAK_CHIP {

   	MOM_force once Q200 Q201 Q206 Q202 Q210 Q203 Q204 Q211 Q212 Q213 Q205 Q208 Q256

	set step1  $mom_cycle_step1
	set step2  $mom_cycle_step2
	set step3  $mom_cycle_step3
	if {$step1==0.0} {
	  set step1 $mom_tool_diameter ;
	  set step2 0.0 ;
	 } else {
 	     if {$step2<0.0} {
 	        set step2 [ expr abs($step2) ] ;
 	      } else {
 	     	if {$step2<=$step1} { set step2 [ expr $step1 - $step2 ] ; }
 	     	}
 	  }
	if {$step3==0.0} { set mom_cycle_cam 0 ; }
        if {$mom_cycle_cam==0} { set  step3 0.0 ;  }

	MOM_do_template cycle_203_drill_deep

  	#MOM_do_template cycle_203
  	#MOM_suppress always N
  	#MOM_do_template tnc_q200 ; # 1-  
  	#MOM_do_template tnc_q201 ; # 
  	#MOM_do_template tnc_q206 ; #    
  	#MOM_do_template tnc_q202 ; #  
  	#MOM_do_template tnc_q202_1 ; #  
  	#MOM_do_template tnc_q210 ; #    
  	#MOM_do_template tnc_q203 ; #  
  	#MOM_do_template tnc_q208 ; #
 	#MOM_do_template tnc_q204 ; # 2-  
 	#MOM_do_template tnc_q212 ; #    
	#set mom_cycle_cam $mom_cycle_cam
  	#MOM_do_template tnc_q213 ; #   
  	#MOM_do_template tnc_q205 ; # .  
  	#MOM_do_template tnc_q211 ; #    
  	#MOM_do_template tnc_q208 ; #      
	#MOM_force once Q256
  	#MOM_do_template tnc_q256 ; #     
  	#MOM_do_template tnc_q257 ; #    
  	#MOM_suppress off    N

	}

	TAP {

	MOM_force once Q200 Q201 Q239 Q203 Q204 Q211

 	MOM_do_template cycle_207_tap

  	#MOM_do_template cycle_203
  	#MOM_suppress always N
  	#MOM_do_template tnc_q200 ; # 1-  
  	#MOM_do_template tnc_q201 ; # 
  	#MOM_do_template tnc_q202_1 ; # 
  	#MOM_do_template tnc_q203 ; #  
 	#MOM_do_template tnc_q204 ; # 2-  
  	#MOM_suppress off    N

	}

	BORE_DWELL {

   	MOM_force once Q200 Q201 Q206 Q211 Q208 Q203 Q204 Q214 Q336

   	MOM_do_template cycle_202_boring

  	#MOM_do_template cycle_202
  	#MOM_suppress always N
  	#MOM_do_template tnc_q200
  	#MOM_do_template tnc_q201
  	#MOM_do_template tnc_q206
  	#MOM_do_template tnc_q211
  	#MOM_do_template tnc_q208
 	#MOM_do_template tnc_q203
 	#MOM_do_template tnc_q204
	#set mom_cycle_cam $mom_cycle_cam
  	#MOM_do_template tnc_q214
  	#MOM_do_template tnc_q336
  	#MOM_suppress off    N

	}

	BORE {

   	MOM_force once Q200 Q201 Q206 Q211 Q208 Q203 Q204 Q214 Q336

   	MOM_do_template cycle_202_boring

  	#MOM_do_template cycle_202
  	#MOM_suppress always N
  	#MOM_do_template tnc_q200
  	#MOM_do_template tnc_q201
  	#MOM_do_template tnc_q206
  	#MOM_do_template tnc_q208
 	#MOM_do_template tnc_q203
 	#MOM_do_template tnc_q204
	#set mom_cycle_cam $mom_cycle_cam
  	#MOM_do_template tnc_q214
  	#MOM_do_template tnc_q336
  	#MOM_suppress off    N

	}


	default { ; }
	}


  }
  incr cycle_step ;

  	MOM_force once X Y
	MOM_do_template cycle_xy
	#  CYCLE CALL
	# MOM_do_template cycle_call

  return ;
}

#=============================================================
proc  MOM_cycle_plane_change {} {
#        .
#=============================================================
  global cycle_init_flag ;   set cycle_init_flag TRUE

  global mom_pos mom_prev_pos

  if {$mom_pos(2) <= $mom_prev_pos(2) } {
   	MOM_do_template rapid_traverse_xy
   	MOM_do_template rapid_spindle_z
   } else {
   	MOM_do_template rapid_spindle_z
   	MOM_do_template rapid_traverse_xy
    }

#    	global mom_pos mom_prev_pos mom_pos_z mom_prev_pos_z
#
#   	if {$mom_pos_z < $mom_prev_pos_z } {
#  		MOM_do_template rapid_cycle_bc
#   		MOM_do_template rapid_cycle_xy
#   		MOM_do_template rapid_cycle_z
#   	} else {
#   		MOM_do_template rapid_cycle_z
#   		MOM_do_template rapid_cycle_bc
#   		MOM_do_template rapid_cycle_xy
#   	}
#  	MOM_do_template cycle_call
#  	set mom_prev_pos_z $mom_pos_z

}


#=============================================================
proc MOM_drill { } {
#       .
#=============================================================

  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name DRILL
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ; #  

}


#=============================================================
proc  MOM_drill_move { } {
#         .
#=============================================================
	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_dwell { } {
#         .
#=============================================================

  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name DRILL_DWELL
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ; #  

}


#=============================================================
proc  MOM_drill_dwell_move { } {
#           .
#=============================================================
	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_deep { } {
#        .
#=============================================================

  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name DRILL_DEEP
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ; #  

}


#=============================================================
proc  MOM_drill_deep_move { } {
#        
#  .
#=============================================================
	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_break_chip { } {
#        
#  .
#=============================================================
  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name DRILL_BREAK_CHIP
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ;

}


#=============================================================
proc  MOM_drill_break_chip_move { } {
#       
#     .
#=============================================================
	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE

}


#=============================================================
proc MOM_tap { } {
#        .
#=============================================================
  global cycle_name
  global cycle_init_flag

  set cycle_init_flag TRUE
  set cycle_name TAP

  global cycle_step ; set  cycle_step 0 ; #  

}


#=============================================================
proc  MOM_tap_move { } {
#       
#   .
#=============================================================
	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore { } {
#       .
#=============================================================
  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name BORE
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ; #  

}


#=============================================================
proc  MOM_bore_move { } {
#       
#  .
#=============================================================
	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_drag { } {
#       .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_drag  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name BORE_DRAG
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ; #  
}


#=============================================================
proc  MOM_bore_drag_move { } {
#       
#  .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_drag  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_no_drag { } {
#      
#    .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_no_drag  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name BORE_NO_DRAG
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ; #  
}


#=============================================================
proc  MOM_bore_no_drag_move { } {
#        
#    .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_no_drag  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE

}


#=============================================================
proc MOM_bore_manual { } {
#      
#    .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_manual  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

}


#=============================================================
proc  MOM_bore_manual_move { } {
#        
#    .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_manual  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

}


#=============================================================
proc MOM_bore_dwell { } {
#         .
#=============================================================
  global cycle_name
  global cycle_init_flag

  set cycle_init_flag TRUE
  set cycle_name BORE_DWELL

  global cycle_step ; set  cycle_step 0 ; #  

}


#=============================================================
proc  MOM_bore_dwell_move { } {
#        
#   .
#=============================================================
	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_back { } {
#        .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_back  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name BORE_BACK
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ; #  
}


#=============================================================
proc  MOM_bore_back_move { } {
#        
#  .
#=============================================================

 	global mom_warning_info
	set mom_warning_info " MOM_bore_back  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE

}


#=============================================================
proc MOM_bore_manual_dwell { } {
#        
#    .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_manual_dwell  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

}


#=============================================================
proc  MOM_bore_manual_dwell_move { } {
#        
#      .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_manual_dwell  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

}


#=============================================================
proc  MOM_drill_counter_sink {} {
#       Standart Drill - Counter Sink.
#=============================================================
	MOM_drill
}


#=============================================================
proc  MOM_drill_counter_sink_move {} {
#       
# Standart Drill - Counter Sink.
#=============================================================
	MOM_drill_move
}


#=============================================================
proc  MOM_drill_csink_dwell {} {
#      
# Standart Drill - Counter Sink Dwell.
#=============================================================
	MOM_drill_dwell
}


#=============================================================
proc  MOM_drill_csink_dwell_move {} {
#       
# Standart Drill - Counter Sink.
#=============================================================
	MOM_drill_dwell_move
}

######################################################################################################

#=============================================================
proc  MOM_load_tool {} {
#       LOAD/TOOL.  
#       MOM_msys.
#=============================================================

}


#=============================================================
proc  MOM_sequence_number {} {
#      Sequence Number.
#=============================================================
	global mom_sequence_mode
	global mom_sequence_number
	global mom_sequence_increment
	global mom_sequence_frequency
	global mom_sequence_text
	if {[isset mom_sequence_mode] == "y"} {
		if {$mom_sequence_mode == "OFF"} {
			MOM_set_seq_off
		} elseif {$mom_sequence_mode == "ON"} {
			MOM_set_seq_on
		} elseif {$mom_sequence_mode == "AUTO"} {
			MOM_output_literal "SEQNO/AUTO "
		} else {
			MOM_output_literal "error: mom_sequence_mode unknown"
		}
	} else {
		MOM_reset_sequence $mom_sequence_number $mom_sequence_increment $mom_sequence_frequency
	}
}


#=============================================================
proc  MOM_set_modes {} {
#       Set Mode.
#=============================================================
	global mom_output_mode
	global mom_arc_mode
	global mom_feed_rate_output_mode
	global mom_parallel_to_axis
	global mom_machine_mode
	global mom_modes_text
	global g_output_mode

# "ABSOLUTE", "INCREMENTAL"
	if {$mom_output_mode == "ABSOLUTE"} {
		set g_output_mode "G90"
		MOM_incremental OFF X Y Z Axis_4th Axis_5th
	} elseif {$mom_output_mode == "INCREMENTAL"} {
		set g_output_mode "G91"
		MOM_incremental ON X Y Z Axis_4th Axis_5th
	}
# "LINEAR", "CIRCULAR"
	if {$mom_arc_mode == "LINEAR"} {
	} elseif {$mom_arc_mode == "CIRCULAR"} {
	}
# "OFF", "IPM", "IPR", "MMPM", "MMPR", "INVERSE"
	if {$mom_feed_rate_output_mode == "FPM"} {
	} elseif {$mom_feed_rate_output_mode == "FPR"} {
	} elseif {$mom_feed_rate_output_mode == "INVERSE"} {
	} elseif {$mom_feed_rate_output_mode == "OFF"} {
	}
# "ZAXIS", "WAXIS", "UAXIS"
	if {$mom_parallel_to_axis == "ZAXIS"} {
	} elseif {$mom_parallel_to_axis == "WAXIS"} {
	} elseif {$mom_parallel_to_axis == "UAXIS"} {
	}
# "MILL", "TURN", "PUNCH", "LASER", "TORCH", "WIRE"
	if {$mom_machine_mode == "MILL"} {
	} elseif {$mom_machine_mode == "TURN"} {
	} elseif {$mom_machine_mode == "PUNCH"} {
	} elseif {$mom_machine_mode == "LASER"} {
	} elseif {$mom_machine_mode == "TORCH"} {
	} elseif {$mom_machine_mode == "WIRE"} {
	}
}


#=============================================================
proc MOM_cutcom_on { } {
#       CUTCOM/ON
#=============================================================
  global mom_cutcom_mode mom_cutcom_status
  global mom_cutcom_adjust_register_defined  mom_cutcom_adjust_register
  global cutcom_mode code_cutcom cutcom_on

proc outCutcom { } {
 global mom_tool_number
 global cutcom_mode code_cutcom cutcom_on
 global mom_cutcom_adjust_register_defined  mom_cutcom_adjust_register

 if { $mom_cutcom_adjust_register_defined!=0} {
	set line_tool [format "TOOL CALL %d.%d Z" $mom_tool_number $mom_cutcom_adjust_register ]
	MOM_output_literal "$line_tool"
    	set   code_cutcom  1
 }
 if { $mom_cutcom_adjust_register_defined==0 && $code_cutcom==1 } {
	set line_tool [format "TOOL CALL %d Z" $mom_tool_number ]
	MOM_output_literal "$line_tool"
 }

}

    switch $mom_cutcom_mode {
    	"OFF" {
         	set cutcom_mode "0"
		#set mom_cutcom_adjust_register  0
	}
	"RIGHT" {
	     outCutcom
       	     set cutcom_mode "R"
      	}
      	"LEFT" {
      	     outCutcom
  	     set cutcom_mode "L"
      	}
      	default { set cutcom_mode "R" ; }
   }

   if {$mom_cutcom_status == "OFF"} {
   	set cutcom_mode "0"
	#set  mom_cutcom_adjust_register  0
    }

   set cutcom_on 1
}


#=============================================================
proc MOM_cutcom_off { } {
#       CUTCOM/OFF
#=============================================================
	global cutcom_mode
	set cutcom_mode "0"
	set cutcom_on 0
	MOM_force once R
}


#=============================================================
proc MOM_spindle_rpm { } {
#       SPLIND/RPM
#=============================================================
	global mom_tool_number mom_spindle_speed mom_contact_status
	global mom_spindle_speed mom_operation_type mom_operation_name
	global mom_tool_name mom_tool_diameter mom_tool_corner1_radius status_block_create
	global spindle_off_flag  line status_tool_change line_tool mom_output_vectors_on
	global mom_imported_path_status mom_coolant_status mom_angle_orient out_m114 mom_tool_count

#         
#       iTNC-530
	if {$status_block_create == "0"} {
		MOM_block_create
		MOM_output_literal "L M115"
	}

	if {$mom_tool_number == 0} {
  		if {[info exists mom_imported_path_status]==1} {
    			if {"NO"==[string toupper "$mom_imported_path_status"]} {
				MOM_abort "\n\nError!\n\t      0   $mom_operation_name.\n\n"
			}
		}
    	}

	if {$status_tool_change == 0} {
		   if {$mom_angle_orient!=0 && $mom_tool_count>1} {
		MOM_output_literal "L M115 "
		      MOM_force once M114
	}
		if {$mom_contact_status == "ON" || $mom_output_vectors_on == "ON"} {
			set line_tool [format "TOOL CALL %d Z S%.0f DL=0.0 DR=0.0 DR2=0.0" $mom_tool_number $mom_spindle_speed]
			MOM_output_literal "$line_tool"
			set line [format "; TOOL: %s D=%.2f " $mom_tool_name $mom_tool_diameter ]
			if {[info exists mom_tool_corner1_radius]} {
				append line [format "r1=%.2f" $mom_tool_corner1_radius ]
			}
   			MOM_output_literal "$line"
   			MOM_output_literal "; POSITIVE VALUES DL, DR, DR2 MEAN THAT THE SIZE MORE ORIGINAL"
			MOM_output_literal "; NEGATIVE VALUES DL, DR, DR2 MEAN THAT THE SIZE LESS ORIGINAL"
			MOM_output_literal "; WARNING: IN 3D CUTTER COMPENSATION MODE"
			MOM_output_literal "; USE THE TOOL OF GREATER DIAMETER MAY GOUGED OF THE PART !!!"
		} else {
			set line_tool [format "TOOL CALL %d Z S%.0f" $mom_tool_number $mom_spindle_speed ]
			MOM_output_literal "$line_tool"

#			set line_tool [format "TOOL CALL S%.0f" $mom_spindle_speed ]
#			MOM_output_literal "$line_tool"

			set line [format "; TOOL: %s D=%.2f " $mom_tool_name $mom_tool_diameter ]
			if {[info exists mom_tool_corner1_radius]} {
				append line [format "r1=%.2f" $mom_tool_corner1_radius ]
			}
   			MOM_output_literal "$line"
		}

		if {$mom_spindle_speed == 0.0} {
  			if {[info exists mom_imported_path_status]==1} {
    				if {"NO"==[string toupper "$mom_imported_path_status"]} {
					MOM_abort "\n\nError!\n\t      0   $mom_operation_name .\n\n"
				}
			}
		}
   		MOM_do_template spindle_rpm
   		set spindle_off_flag 1
   		set status_tool_change 1
   	} else {
   		if {$spindle_off_flag == 0}	{
	                MOM_force once M_spindle F
   		MOM_do_template spindle_rpm
   			set spindle_off_flag 1
		}
      }
	if {$mom_operation_type == "Variable-axis Surface Contouring"	||
		$mom_operation_type == "Sequential Mill Main Operation"	||
		$mom_operation_type == "Zig-Zag Surface" } {
		#MOM_output_literal "L M126"
	}
}


#=============================================================
proc  MOM_spindle_off {} {
#       SPLIND/OFF.
#=============================================================
	global spindle_off_flag

         MOM_do_template spindle_off
         set spindle_off_flag 0
}


#=============================================================
proc  MOM_coolant_on {} {
#       COOLANT/ON.
#=============================================================
	COOLANT_SET
	MOM_force Once M_coolant
	MOM_do_template coolant_on
}


#=============================================================
proc  MOM_coolant_off {} {
#       COOLANT/OFF.
#=============================================================
	COOLANT_SET
	MOM_do_template coolant_off
}

#=============================================================
proc  MOM_clamp_on {} {
#       COOLANT/ON.
#=============================================================
	

	MOM_do_template clamp4th_on
}


#=============================================================
proc  MOM_clamp_off {} {
#       COOLANT/OFF.
#=============================================================
	
	MOM_do_template clamp4th_off
}



#=============================================================
proc  MOM_opstop {} {
#       OPTIONAL STOP.
#=============================================================
	MOM_do_template opstop
}


#=============================================================
proc  MOM_stop {} {
#       PROGRAM STOP.
#=============================================================
	MOM_do_template stop
}


#=============================================================
proc  MOM_opskip_on {} {
#       OPTIONAL SKIP/ON.
#=============================================================
	MOM_set_line_leader always "/"
}


#=============================================================
proc  MOM_opskip_off {} {
#       OPTIONAL SKIP/OFF.
#=============================================================
	MOM_set_line_leader off "/"
}


#=============================================================
proc  MOM_delay {} {
#       DELAY.
#=============================================================
	global mom_delay_value

	MOM_do_template delay_1
	MOM_do_template delay_2
}


#=============================================================
proc  MOM_auxfun {} {
#      
# AUXILIARY FUNCTION.
#=============================================================
	MOM_do_template auxiliary
}


#=============================================================
proc  MOM_prefun {} {
#      
# PREPARATORY FUNCTION.
#=============================================================
	MOM_do_template preparatory
}


#=============================================================
proc  MOM_length_compensation {} {
#      
# TOOL LENGTH COMPENSATION.
#=============================================================
}


#=============================================================
proc  MOM_tool_preselect {} {
#       TEXT.
#=============================================================
}


#=============================================================
proc MOM_zero {} {
#        ZERO
#=============================================================
	global mom_work_coordinate_number
	MOM_output_literal "CYCL DEF 7.0 DATUM SHIFT"
	MOM_output_literal "CYCL DEF 7.1 #$mom_work_coordinate_number"
#	MOM_output_literal "CYCL DEF 7.2 Y0.0"
#	MOM_output_literal "CYCL DEF 7.3 Z0.0"
	MOM_output_literal "; SET NULL POINT SHIFT"

		MOM_force once  X Y Z
}


#=============================================================
proc  MOM_text {} {
#        .
#=============================================================
	global mom_user_defined_text
	global mom_record_fields
	global mom_record_text
	global MCSROT_mode
	global MCSROT_flag
	global is_MCSROT_matrix_set
	global first_move_after_MCSROT
	global prog_number mom_work_coordinate_number

	switch $mom_record_fields(0) {
	"INSERT"
	{
		MOM_output_literal $mom_record_text
	}
	"ZERO"
	{
		set mom_work_coordinate_number $mom_record_fields(1)
		MOM_zero
	}
	"MCSROT"
	{
		set MCSROT_mode $mom_record_fields(1)
		if {$mom_record_fields(1) == "OFF"} {
			set MCSROT_flag 0
			set is_MCSROT_matrix_set 0
			set first_move_after_MCSROT 0
			MOM_suppress off K
			MOM_do_template cancel_rotate_mcs
		} else {
			set MCSROT_flag 1
		}
	}
	"PARTNO"
	{
		set mom_record_text [string trim $mom_record_text " "]
		set temp [split $mom_record_text " "]
		set prog_number [lindex $temp 0]
		PROGRAM_START
	}
	default
		{ MOM_output_literal "$mom_user_defined_text" }
	}
}


#=============================================================
proc PB_CMD_before_motion { } {
#        .
#=============================================================

	global mom_mcs_goto mom_tool_axis mom_alt_pos mom_seqnum warning_1 nn mom_prev_tool_axis
	global mom_pos mom_out_angle_pos mom_motion_type mom_spindle_speed mom_warning_info
	global mom_current_motion mom_pos_a1 mom_alt_pos_a1
	global mom_operation_type mom_pos mom_clearance_plane_point mom_coolant_status
	global mom_nxt_motion_type mom_nxt_pos mom_clearance_plane_status mom_angle_orient mom_operation_name

	global out_m114 mom_machine_time_dmu_1 mom_motion_distance mom_feed_rate mom_warning_info out_dist mom_motion_distance mom_motion_type
  global mom_prev_out_angle_pos mom_motion_event f_clamp

if {$mom_spindle_speed == 0} {
	set mom_warning_info "  $mom_operation_name \n      \n S=0"
	MOM_output_to_listing_device $mom_warning_info
	MOM_abort $mom_warning_info
}

if {$mom_warning_info== "unable to determine valid rotary positions" } {
	MOM_abort "\n\nError!\n\t      .\n\n"
}

if { $mom_motion_type=="ENGAGE" && $mom_coolant_status != "FLOOD"} {
  set  mom_coolant_status   "FLOOD"
	MOM_do_template coolant_on
}

if { $mom_motion_type=="RETURN" || $mom_motion_type=="GOHOME"} {
  set  mom_coolant_status   "OFF"
	MOM_do_template coolant_off
}

  set  n5 [ expr ( $mom_motion_distance /$mom_feed_rate)]
  set mom_machine_time_dmu_1  [ expr ( $mom_machine_time_dmu_1 + $n5 )]

  if {$mom_angle_orient!=0 } {
       set out_m114  114
		} else {
   if {[format "%.6f" $mom_out_angle_pos(0)]!=0 || [format "%.6f" $mom_out_angle_pos(1)]!=0 } {
#       MOM_force off M114
       set out_m114  114
   }

   if {[format "%.6f" $mom_out_angle_pos(0)]==0 && [format "%.6f" $mom_out_angle_pos(1)]==0 } {
       set  out_m114  115
   }
}
#
   
if {$mom_warning_info== "secondary rotary position being used" || \
	   ($mom_tool_axis(2)<0 && $mom_prev_tool_axis(2)>0 )  ||
      ($mom_tool_axis(2)>0 && $mom_prev_tool_axis(2)<0 ) } {
     incr nn
     set warning_1($nn) [format "; :   %.0f      B" $mom_seqnum ]
     set mom_warning_info ""
}

  set  ff1 [format "%.6f" $mom_prev_out_angle_pos(0)]  
  set  ff2 [format "%.6f" $mom_prev_out_angle_pos(1)] 
  set  f1 [format "%.6f" $mom_out_angle_pos(0)] 
   set  f2 [format "%.6f" $mom_out_angle_pos(1)] 

if { $mom_operation_type=="Point to Point" && $mom_motion_event!="initial_move"} {
  if {$ff1!=$f1 || $ff2!=$f2} {
     MOM_output_literal "L M44"
     MOM_output_literal "L M45"
     set   f_clamp   1
  }
  if {$ff1==$f1 && $ff2==$f2 && $f_clamp==1} {
     MOM_output_literal "L M64"
     MOM_output_literal "L M65"
     set   f_clamp   0
  }
}

#   PB_limit_angle
#      
  if {$mom_motion_type=="CUT" || $mom_motion_type=="FIRSTCUT" || $mom_motion_type=="ENGAGE"} {
       set out_dist  [ expr ( $mom_motion_distance + $out_dist )]
   }
}

#=============================================================
proc PB_limit_angle {} {
#      .
#=============================================================
 global  mom_warning_info
 global  mom_kin_4th_axis_min_limit  mom_kin_4th_axis_max_limit
 global  mom_kin_5th_axis_min_limit  mom_kin_5th_axis_max_limit
 global  mom_out_angle_pos

 #set mom_kin_4th_axis_min_limit		-180.000
 #set mom_kin_4th_axis_max_limit		30.000
 #set mom_kin_5th_axis_min_limit		-90.000
 #set mom_kin_5th_axis_max_limit		90.000

 	set mom_out_angle_pos(0) [format %.4f $mom_out_angle_pos(0)]
	set mom_out_angle_pos(1) [format %.4f $mom_out_angle_pos(1)]

#     4- A   5- B -    ( )
set fl 0
  if {$mom_out_angle_pos(0)>$mom_kin_4th_axis_max_limit} {
    set mom_warning_info "      $mom_kin_4th_axis_max_limit  ()"
    set fl 1
  }
  if {$mom_out_angle_pos(0)<$mom_kin_4th_axis_min_limit} {
    set mom_warning_info "      $mom_kin_4th_axis_min_limit  ()"
    set fl 1
  }
  if {$mom_out_angle_pos(1)>$mom_kin_5th_axis_max_limit} {
    set mom_warning_info "      $mom_kin_5th_axis_max_limit  ()"
    set fl 1
  }
  if {$mom_out_angle_pos(1)<$mom_kin_5th_axis_min_limit} {
    set mom_warning_info "      $mom_kin_5th_axis_min_limit  ()"
    set fl 1
  }

 if {$fl==1} {
 	#MOM_output_to_listing_device $mom_warning_info  ;
 	MOM_catch_warning ;
 	MOM_abort "\n\n\t $mom_warning_info \n\n"  ;
  }

 return 0 ;
}


#=============================================================
proc MOM_machine_mode {} {
#      .
#=============================================================
	MOM_start_of_group
}


######################################################################################################


#=============================================================
proc MOM_smooth_tool_path { } {
#      .
#=============================================================
	global mom_smooth_path
}


#=============================================================
proc MOM_tolerance_cycle { } {
#       
#=============================================================
	global mom_tolerance_on_off
	global mom_operation_type
	global mom_inside_outside_tolerances
	global tolerances mom_tolerance
	global temp

	MOM_force once Tol

  	if {$mom_operation_type == "Variable-axis Surface Contouring"  	||
		$mom_operation_type == "Cavity Milling" 					||
		$mom_operation_type == "Fixed-axis Surface Contouring"  	||
		$mom_operation_type == "Planar Milling"  				||
		$mom_operation_type == "Sequential Mill Main Operation"  	||
		$mom_operation_type == "Zig-Zag Surface" } {
  		set temp [expr $mom_inside_outside_tolerances(0) + $mom_inside_outside_tolerances(1)]
  		set tolerances [expr $temp/2]
#       set tolerances  $mom_tolerance
       set   mom_tolerance_on_off   "ON"
  	}
}


#=============================================================
proc MOM_spindle_orient { } {
#      .
#=============================================================
	global mom_angle_orient
#	MOM_force once Angle
#	MOM_do_template spindle_orient_1
#	MOM_do_template spindle_orient_2
}


proc COUNT_alk {x y alk} {
#_______________________________________________________________________________
# This procedure is executed for  ygol  megdy  vectorom i X
#_______________________________________________________________________________
	   set pi 3.1415927
       if {$x == 0. && $y==0.} {
	       set alk [expr (3.*$pi/2.)]
	       return $alk
	       }
      if {$x < 0.} {
	       set alk [expr ($pi + atan($y/$x))]
	       return $alk
	       }
      if {$x == 0.} {
	    if {$y > 0.} {
	       set alk [expr ($pi/2)]
	       } else {
		set alk [expr (3.*$pi/2.)]
		}
		  return $alk
	       }
       if {$x > 0.} {
	      set alk [expr (atan($y/$x))]
	       if {$alk < 0.} { set alk [expr ($alk+2.*$pi)] }
	       if {$alk == 0.} { set alk 0. }
	       }
	      return $alk
}
#=============================================================
proc MOM_rotate { } {
#       
#=============================================================
	global mom_rotate_axis_type mom_rotation_angle
	global rot_table_1 rot_table_2 rot_table_3 status_rot
	global a_angle  b_angle

        set status_rot 1

	set rot_table_1 [format "CYCL DEF 19.0 WORKING PLANE"]
	if { $mom_rotate_axis_type=="AAXIS" } {
		set rot_table_2 [format "CYCL DEF 19.1 A%.3f " $mom_rotation_angle]
		set a_angle $mom_rotation_angle
	}
	if { $mom_rotate_axis_type=="BAXIS" } {
		set rot_table_3 [format "CYCL DEF 19.2 B%.3f " $mom_rotation_angle]
		set b_angle $mom_rotation_angle
	}
}
